
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "common.ch"

PROCEDURE AppSys()
RETURN

PROCEDURE main()
LOCAL oDlg, oPS, oSourcePS
LOCAL oDraw
LOCAL aSizeDesktop := AppDesktop():currentSize()
LOCAL nEvent := NIL, mp1 := NIL, mp2 := NIL, oObj := NIL
LOCAL aPos   := { 0,0 }
LOCAL aSize  := { 0,0 }
LOCAL aDraw  := { 0,0 }
LOCAL oStatic
LOCAL oBitmap
LOCAL oIcon
LOCAL nWait  := 20
LOCAL nXsize := 180
LOCAL nYsize := 80
LOCAL oThread := Thread():new()

   oBitmap := XbpBitmap():new():create()
   oBitmap:load(,100)
*  oBitmap:loadfile("mwb1024eve.bmp")
*  oBitmap:TransparentClr := oBitmap:GetDefaultBGColor()

   aSize[1] := oBitmap:xSize
   aSize[2] := oBitmap:ySize

   IF aSize[1]  > aSizeDesktop [1] -100
      aSize[1] := aSizeDesktop [1] -100
   ENDIF
   IF aSize[2]  > aSizeDesktop [2] -100
      aSize[2] := aSizeDesktop [2] -100
   ENDIF

   oDlg             := XbpDialog():new( AppDesktop(),, aPos, {0,0},, .F. )
   oDlg:taskList    := .T.
   oDlg:title       := "moving Bitmap over Bitmap"
   oDlg:border      := XBPDLG_RAISEDBORDERTHICK_FIXED
   oDlg:maxButton   := .F.
   oDlg:minButton   := .T.

   // use o:clientSize
   oDlg:clientSize  := aSize
   // avoid flickering
   oDlg:drawingArea:clipChildren := .T.
   oDlg:create()

   aDraw := oDlg:drawingArea:Currentsize()

   oStatic  := XbpStatic():new( oDlg:drawingArea,,{0,0},aDraw )
   oStatic:type    := XBPSTATIC_TYPE_BITMAP
   oStatic:caption := oBitmap
   oStatic:create()

   oIcon := XbpBitmap():new():create()
   oIcon:load(,101)
*  oIcon:loadfile("taxi1.bmp")
   oIcon:TransparentClr := oIcon:GetDefaultBGColor()

   nXsize := oIcon:Xsize
   nYsize := oIcon:Ysize

   oDraw    := XbpStatic():new(          oStatic,,{0,0},{nXsize,nYsize},{{XBP_PP_BGCLR,XBPSYSCLR_TRANSPARENT}} )
*  oDraw    := XbpStatic():new( oDlg:drawingArea,,{0,0},{nXsize,nYsize},{{XBP_PP_BGCLR,XBPSYSCLR_TRANSPARENT}} )
   oDraw:type    := XBPSTATIC_TYPE_BITMAP
   oDraw:caption := oIcon
   oDraw:create()

   CenterControl(oDlg)
   SetAppWindow( oDlg )
   SetAppFocus( oDlg )
   oDlg:Show()

   oThread:start(  {|| Moveit(oDraw,aDraw,10) } )
   oThread:setInterval(nWait/2)

   nEvent := xbe_None
   DO WHILE nEvent != xbeP_Close
       nEvent := AppEvent ( @mp1, @mp2, @oObj, nWait )
       DO CASE
          CASE nEvent == xbe_None

          CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
             EXIT

       OTHERWISE
          oObj:HandleEvent( nEvent, mp1, mp2 )
       ENDCASE
   ENDDO

   oThread:setInterval(NIL)
   oDlg:Destroy()

RETURN

FUNCTION Moveit(oDraw,aDraw,nStep)
LOCAL aSize    := oDraw:CurrentSize()

STATIC aPos    := { 0,0 }

DEFAULT nStep TO 10

   IF aPos[1] = 0
      aPos := ACLONE(aDraw)
      aPos[2] := 0
   ENDIF

   aPos[1] -= nStep
   IF aPos[1]  < aSize[1] * -1
      aPos[1] := aDraw[1] - aSize[1]
   ENDIF

   oDraw:SetPos(aPos)

RETURN NIL

*
* eof
*